#pragma once
#include <map>
#include<vector>
#include <string>

using namespace std;
/**
     Żȼ
*/
class CivSchedulingCompute
{
public:

	// 
	enum SchdulingType
	{
		PumpScheduling, // ˮõ
		PBVScheduling // ѹƶ
	};

	explicit CivSchedulingCompute(SchdulingType schedulingType);

	// ü
	void setMonitors(const vector<string>& monitor);

	// inpļ
	bool openFile(const string& inpFILE);

	// ˮ
	bool calculate();

	// 㣬رļ
	void close();

	// ˮÿ״̬
	void updatePumpStatus(const map<string, int>& pumpStatus);

	// ȡֵ
	void getMonitorsValue(vector<map<string, double>>& monitorMap);

	// ѹƶѹ
	void updatePBVSettings(const string& sn, double pressure);

	// ȡÿʱĵ
	float totalEnergy(int index);

private:
	// ֵ
	void saveResult(int time);

	// ȡˮõܺ
	void getPumpEnergy(int time);
private:
	std::string mRptFile;
	std::string mBinFile;

	// ˮñźcodeӳ
	vector<string> mMonitors;

	 // 
	int  mErrcode = 0;

	// ˮõ״̬
	map<string, int> mPumpStatus;

	// ˮĵ
	vector<map<string, float>> mPumpEnergy;

	// 洢ļֵ
	vector<map<string, double>> mMonitorsValue;

	SchdulingType mChdulingType;

};
